import Tree from './tree';
import EventEmitter from 'eventemitter3';
import Storage from './storage';
import { TreeOptions, KeyType } from './ui-tree.type';
export declare class UITree extends Tree {
    selectedKeyStorage: Storage;
    checkedKeysStorage: Storage;
    expandedKeysStorage: Storage;
    visibleKeysStorage: Storage;
    loading: boolean;
    disabled: boolean;
    checkable: boolean;
    selectable: boolean;
    checkStrictly: boolean;
    autoExpandParent: boolean;
    replaceFields: {
        children: string;
        title: string;
        key: string;
        isLeaf: string;
    } & import("./ui-tree.type").ReplaceFields;
    loadData: (node?: any) => any[];
    ee: EventEmitter<string | symbol, any>;
    on: <T extends string | symbol>(event: T, fn: (...args: any[]) => void, context?: any) => EventEmitter<string | symbol, any>;
    off: <T extends string | symbol>(event: T, fn?: ((...args: any[]) => void) | undefined, context?: any, once?: boolean | undefined) => EventEmitter<string | symbol, any>;
    constructor(options?: TreeOptions);
    get flat(): any[];
    get nodeInstanceOption(): {
        disabled: boolean;
        checkable: boolean;
        selectable: boolean;
        replaceFields: {
            children: string;
            title: string;
            key: string;
            isLeaf: string;
        } & import("./ui-tree.type").ReplaceFields;
        nodeMapStorage: any;
        selectedKeyStorage: Storage;
        checkedKeysStorage: Storage;
        expandedKeysStorage: Storage;
        visibleKeysStorage: Storage;
    };
    emitChangeFlat(): void;
    emitSelectedChange(key: KeyType): void;
    makeRoot(data: any[]): import("./ui-node").default[];
    getExpandedNodes(): Promise<any[]>;
    getCheckedNodes(): Promise<any[]>;
    getSelectedNode(): Promise<any>;
    getVisibleKeys(): Promise<any[]>;
    expand(key: KeyType, expanded: boolean): Promise<void>;
    check(key: KeyType, checked: boolean): Promise<void>;
    select(key: KeyType, selected: boolean): Promise<void>;
    reload(key: KeyType): Promise<void>;
    expandKeys(expanded: boolean, keys?: KeyType[]): Promise<void>;
    expandExistKeys(expanded: boolean, keys?: KeyType[]): Promise<void>;
    checkKeys(keys: KeyType[], checked?: boolean): Promise<void>;
    expandAll(): Promise<void>;
    setVisibleKeys(visibleKeys: KeyType[]): Promise<void>;
}
export default UITree;
